#include <gpstdio.h>
#include <gpstdlib.h>

#include "dirent.h"
#include "types.h"

#define CHECK_INITIALISED if (!initialised) { GpFatInit(); initialised = 1; }

static int initialised = 0;

DIR *opendir(const char *name) {
	DIR *dir;
	CHECK_INITIALISED;
	dir = (DIR *)malloc(sizeof(DIR));
	dir->name = (char *)malloc((strlen(name)+1)*sizeof(char));
	strncpy(dir->name, name, strlen(name)+1);
	GpDirEnumNum(name, &dir->num_ents);
	dir->index = 0;
	return dir;
}

int closedir(DIR *dir) {
	free(dir->name);
	free(dir);
	return 0;
}

struct dirent *readdir(DIR *dir) {
	GPDIRENTRY file;
	unsigned long dummy;
	CHECK_INITIALISED;
	if (dir->index >= dir->num_ents) {
		return NULL;
	}
	GpDirEnumList(dir->name, dir->index++, 1, &file, &dummy);
	strncpy(dir->current.d_name, file.name, strlen(file.name)+1);
	return &dir->current;
}
